<?php

namespace CRM\Service;

use CRM\Factory\CrmTermometroDeOportunidadeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmTermometroDeOportunidadeService
{

    protected $CrmTermometroDeOportunidadeFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmTermometroDeOportunidadeFactory $CrmTermometroDeOportunidadeFactory)
    {
        $this->CrmTermometroDeOportunidadeFactory    = $CrmTermometroDeOportunidadeFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getOpportunityThermometer()
    {
        return $this->CrmTermometroDeOportunidadeFactory->getOpportunityThermometer();
    }

    public function getFieldColor()
    {
        return $this->CrmTermometroDeOportunidadeFactory->getFieldColor();
    }

    public function saveThermometerOpportunity($rows)
    {
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        $this->connection->beginTransaction();
        try {
            foreach ($rows["DRG"] as $row) {

                if ($row["NRTERMOPORTUNI"] == 0) {

                    $nrtermoportuni = $this->newCode->getCodeByTableName("CRM_TERMOPORTUNI", $nrorg, 1, 5, false);
                    $params = array(
                        "NRTERMOPORTUNI"   => $nrtermoportuni,
                        "IDATIVO"          => $row["IDATIVO"],
                        "NRORG"            => $nrorg,
                        "NMTERMOPORTUNI"   => $row["NMTERMOPORTUNI"],
                        "DSCORHEXADECIMAL" => $row["DSCORHEXADECIMAL"],
                        "CDOPERINCLUSAO"   => $cdoperador,
                        "CDOPERULTATU"     => $cdoperador,
                        "NRORGINCLUSAO"    => $nrorg,
                        "NMTERMOPORTUNI"   => $row["NMTERMOPORTUNI"],
                        "NRORGULTATU"      => $nrorg,
                    );
                    $this->CrmTermometroDeOportunidadeFactory->saveThermometerOpportunity($params);
                } else {

                    $params = array(
                        "NRTERMOPORTUNI"   => $row["NRTERMOPORTUNI"],
                        "IDATIVO"          => $row["IDATIVO"],
                        "NRORG"            => $nrorg,
                        "NMTERMOPORTUNI"   => $row["NMTERMOPORTUNI"],
                        "DSCORHEXADECIMAL" => $row["DSCORHEXADECIMAL"],
                        "CDOPERINCLUSAO"   => $cdoperador,
                        "CDOPERULTATU"     => $cdoperador,
                        "NRORGINCLUSAO"    => $nrorg,
                        "NRORGULTATU"      => $nrorg,
                    );

                    $this->CrmTermometroDeOportunidadeFactory->updateNewThermometer($params);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteThermometerOpportunity($rows)
    {
        $this->connection->beginTransaction();
        try {
            $params = implode(',', $rows["NRTO"]);
            $this->CrmTermometroDeOportunidadeFactory->deleteThermometerOpportunity($params);
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
