/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCTPAGAR                                              */
/* Tabela : TIPOCTPAGAR                                                       */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOCTPAGAR
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCTPAGAR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPCP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTPCTPAGAR,0) <> NVL(:NEW.CDTPCTPAGAR,0)) OR
         (NVL(:OLD.DSTPCTPAGAR,0) <> NVL(:NEW.DSTPCTPAGAR,0)) OR
         (NVL(:OLD.IDCTBLCTPAG,0) <> NVL(:NEW.IDCTBLCTPAG,0)) OR
         (NVL(:OLD.DSDEFACTPAG,0) <> NVL(:NEW.DSDEFACTPAG,0)) OR
         (NVL(:OLD.CDCLASSFINA,0) <> NVL(:NEW.CDCLASSFINA,0)) OR
         (NVL(:OLD.IDUTLANCCPAG,0) <> NVL(:NEW.IDUTLANCCPAG,0))
         THEN
         :NEW.DTULTATUTPCP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCTPAGAR', '', 'CDTPCTPAGAR='||:OLD.CDTPCTPAGAR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCTPAGAR MODIFY DTULTATUTPCP DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOCTPAGAR','5.05.045'); END;
/

