import { ZdPage } from '@zeedhi/vue';

const routes = [
  {
    path: '/auth/login',
    name: 'login',
    component: ZdPage,
    props: {
      path: 'login',
      local: true,
    },
  },
  {
    path: '/',
    name: 'home',
    component: ZdPage,
    props: () => ({
      path: 'home',
      local: true,
    }),
  },
  {
    path: '/modules/:module/:page',
    name: 'microservice',
    component: () => import('../views/Microservice.vue'),
  },
  {
    path: '/ger10120_segmento_mercado',
    name: 'Sergmento Mercado',
    component: ZdPage,
    props: {
      path: '/ger10120_segmento_mercado/ger10120_segmento_mercado',
      local: true,
    },
  },
  {
    path: '/ger91600_tipo_atividade',
    name: 'Tipo de Atividade',
    component: ZdPage,
    props: {
      path: '/ger91600_tipo_atividade/ger91600_tipo_atividade',
      local: true,
    },
  },
  {
    path: '/crm_modo_de_divulgacao',
    name: 'Modo de Divulgação',
    component: ZdPage,
    props: {
      path: '/crm_modo_de_divulgacao/crm_modo_de_divulgacao',
      local: true,
    },
  },
  {
    path: '/crm_cargoInterloc',
    name: 'Cargos Interlocutor',
    component: ZdPage,
    props: {
      path: '/crm_cargoInterloc/crm_cargoInterloc',
      local: true,
    },
  },
  {
    path: '/crm_next_modoReceberInfo',
    name: 'Modo de Receber Info',
    component: ZdPage,
    props: {
      path: '/crm_next_modoReceberInfo/crm_next_modoReceberInfo',
      local: true,
    },
  },
  {
    path: '/crm_ramo_de_atividade',
    name: 'Ramo de Atividade',
    component: ZdPage,
    props: {
      path: '/crm_ramo_de_atividade/crm_ramo_de_atividade',
      local: true,
    },
  },
  {
    path: '/crm_classificacao_de_oportunidade',
    name: 'Classificação de Oportunidade',
    component: ZdPage,
    props: {
      path: '/crm_classificacao_de_oportunidade/crm_classificacao_de_oportunidade',
      local: true,
    },
  },
  {
    path: '/crm_classificacao_parceiro',
    name: 'Classificação do Parceiro',
    component: ZdPage,
    props: {
      path: '/crm_classificacao_parceiro/crm_classificacao_parceiro',
      local: true,
    },
  },
  {
    path: '/crm00040_000_tipo_revenda',
    name: 'Tipo de revenda',
    component: ZdPage,
    props: {
      path: '/TipoDeRevenda/crm00040_000_resale_type',
      local: true,
    },
  },
  {
    path: '/crm00040_001_dados_tipo_revenda',
    name: '',
    component: ZdPage,
    props: {
      path: '/TipoDeRevenda/crm00040_001_data_resale_type',
      local: true,
    },
  },
  {
    path: '/crm_termometro_de_oportunidade',
    name: 'Termômetro de Oportunidade',
    component: ZdPage,
    props: {
      path: '/crm_termometro_de_oportunidade/crm_termometro_de_oportunidade',
      local: true,
    },
  },
  {
    path: '/crm_modalidade_de_pagamento',
    name: 'Modalidade de Pagamento',
    component: ZdPage,
    props: {
      path: '/crm_modalidade_de_pagamento/crm_modality_payment',
      local: true,
    },
  },
  {
    path: '/crm_fase_de_negociacao',
    name: 'Fase de Negociação',
    component: ZdPage,
    props: {
      path: '/crm_fase_de_negociacao/crm_fase_de_negociacao',
      local: true,
    },
  },
  {
    path: '*',
    component: ZdPage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
];

export default routes;
